"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.open = void 0;
var url_1 = require("url");
var events_1 = require("events");
var react_native_1 = require("react-native");
var react_native_inappbrowser_reborn_1 = require("react-native-inappbrowser-reborn");
var LOADED_EVENT = 'loaded';
var CLOSED_EVENT = 'closed';
var ERROR_EVENT = 'error';
var PopupBrowser = /** @class */ (function (_super) {
    __extends(PopupBrowser, _super);
    function PopupBrowser() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.isOpen = false;
        _this.isRedirected = false;
        return _this;
    }
    PopupBrowser.prototype.isClosed = function () {
        return !this.isOpen;
    };
    PopupBrowser.prototype.onLoaded = function (listener) {
        return this.on(LOADED_EVENT, listener);
    };
    PopupBrowser.prototype.onClosed = function (listener) {
        return this.on(CLOSED_EVENT, listener);
    };
    PopupBrowser.prototype.onError = function (listener) {
        return this.on(ERROR_EVENT, listener);
    };
    PopupBrowser.prototype.handleDeeplinkCallback = function (_a) {
        var url = _a.url;
        if (this.isRedirected) {
            return;
        }
        // Check if this is the expected callback
        if (url && url.indexOf(this.authUrl.query.redirect_uri) === 0) {
            this.isRedirected = true;
            this.emit(LOADED_EVENT, { url: url });
        }
    };
    PopupBrowser.prototype.open = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, react_native_inappbrowser_reborn_1.InAppBrowser.isAvailable()];
                    case 1:
                        if ((_a.sent()) == false) {
                            throw new Error('In-app browser not available.');
                        }
                        this.authUrl = url_1.parse(url, true);
                        ;
                        react_native_1.Linking.addEventListener('url', this.handleDeeplinkCallback.bind(this));
                        this.isOpen = true;
                        this.authPromise = react_native_inappbrowser_reborn_1.InAppBrowser.openAuth(url, null)
                            .then(function (authResult) {
                            var loadedArgs = { url: url };
                            // If result is not successful, just wait for handleDeeplinkCallback to be called
                            if (authResult.type === 'success' && authResult.url) {
                                loadedArgs.url = authResult.url; // Provide the full url containing the auth code
                                _this.isRedirected = true;
                                _this.emit(LOADED_EVENT, loadedArgs);
                            }
                        })
                            .catch(function (err) {
                            _this.emit(ERROR_EVENT, err);
                        });
                        return [2 /*return*/, this];
                }
            });
        });
    };
    PopupBrowser.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                react_native_1.Linking.removeEventListener('url', this.handleDeeplinkCallback);
                this.isOpen = false;
                this.isRedirected = false;
                this.authPromise = null;
                this.emit(CLOSED_EVENT);
                return [2 /*return*/];
            });
        });
    };
    return PopupBrowser;
}(events_1.EventEmitter));
function open(url) {
    return __awaiter(this, void 0, void 0, function () {
        var popup;
        return __generator(this, function (_a) {
            popup = new PopupBrowser();
            return [2 /*return*/, popup.open(url)];
        });
    });
}
exports.open = open;
//# sourceMappingURL=popup.js.map