"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.unregister = exports.register = void 0;
var react_native_push_notification_1 = __importDefault(require("react-native-push-notification"));
var http_1 = require("kinvey-js-sdk/lib/http");
var isFunction_1 = __importDefault(require("lodash/isFunction"));
function registerDeviceWithKinvey(os, token) {
    return __awaiter(this, void 0, void 0, function () {
        var requestOptions;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    requestOptions = {
                        method: http_1.HttpRequestMethod.POST,
                        auth: http_1.KinveyHttpAuth.Session,
                        url: http_1.formatKinveyBaasUrl(http_1.KinveyBaasNamespace.Push, '/register-device'),
                        body: {
                            platform: os.toLowerCase(),
                            framework: 'react-native',
                            deviceId: token,
                            service: 'firebase'
                        }
                    };
                    return [4 /*yield*/, new http_1.KinveyHttpRequest(requestOptions).execute()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function register(options) {
    if (options === void 0) { options = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var promise;
        return __generator(this, function (_a) {
            promise = new Promise(function (resolve, reject) {
                react_native_push_notification_1.default.configure({
                    permissions: options.permissions,
                    popInitialNotification: options.popInitialNotification,
                    onNotification: options.onNotification,
                    onRegister: function (info) {
                        return __awaiter(this, void 0, void 0, function () {
                            var error_1;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        _a.trys.push([0, 2, , 3]);
                                        return [4 /*yield*/, registerDeviceWithKinvey(info.os, info.token)];
                                    case 1:
                                        _a.sent();
                                        if (isFunction_1.default(options.onRegister)) {
                                            options.onRegister(info);
                                        }
                                        resolve(info.token);
                                        return [3 /*break*/, 3];
                                    case 2:
                                        error_1 = _a.sent();
                                        reject(error_1);
                                        return [3 /*break*/, 3];
                                    case 3: return [2 /*return*/];
                                }
                            });
                        });
                    }
                });
            });
            return [2 /*return*/, promise];
        });
    });
}
exports.register = register;
function unregisterDeviceWithKinvey(os, token) {
    return __awaiter(this, void 0, void 0, function () {
        var request;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    request = new http_1.KinveyHttpRequest({
                        method: http_1.HttpRequestMethod.POST,
                        auth: http_1.KinveyHttpAuth.Session,
                        url: http_1.formatKinveyBaasUrl(http_1.KinveyBaasNamespace.Push, '/unregister-device'),
                        body: {
                            platform: os.toLowerCase(),
                            framework: 'react-native',
                            deviceId: token,
                            service: 'firebase'
                        }
                    });
                    return [4 /*yield*/, request.execute()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function unregister() {
    return __awaiter(this, void 0, void 0, function () {
        var promise;
        return __generator(this, function (_a) {
            promise = new Promise(function (resolve, reject) {
                react_native_push_notification_1.default.unregister();
                react_native_push_notification_1.default.configure({
                    onRegister: function (info) {
                        return __awaiter(this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                try {
                                    unregisterDeviceWithKinvey(info.os, info.token);
                                    react_native_push_notification_1.default.unregister();
                                    resolve(info.token);
                                }
                                catch (error) {
                                    reject(error);
                                }
                                return [2 /*return*/];
                            });
                        });
                    }
                });
            });
            return [2 /*return*/, promise];
        });
    });
}
exports.unregister = unregister;
//# sourceMappingURL=push.js.map