"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.clearDatabase = exports.clear = exports.removeById = exports.save = exports.findById = exports.count = exports.find = void 0;
var async_storage_1 = __importDefault(require("@react-native-async-storage/async-storage"));
var SEPARATOR = ':';
function getKey(dbName, tableName, id) {
    return "" + dbName + SEPARATOR + tableName + SEPARATOR + id;
}
function getTableKeys(dbName, tableName) {
    return __awaiter(this, void 0, void 0, function () {
        var allKeys;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, async_storage_1.default.getAllKeys()];
                case 1:
                    allKeys = _a.sent();
                    return [2 /*return*/, allKeys.filter(function (key) { return key.indexOf("" + dbName + SEPARATOR + tableName + SEPARATOR) === 0; })];
            }
        });
    });
}
function find(dbName, tableName) {
    return __awaiter(this, void 0, void 0, function () {
        var tableRecords, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _b = (_a = async_storage_1.default).multiGet;
                    return [4 /*yield*/, getTableKeys(dbName, tableName)];
                case 1: return [4 /*yield*/, _b.apply(_a, [_c.sent()])];
                case 2:
                    tableRecords = _c.sent();
                    return [2 /*return*/, tableRecords.map(function (_a) {
                            var _b = __read(_a, 2), key = _b[0], value = _b[1];
                            return JSON.parse(value);
                        })];
            }
        });
    });
}
exports.find = find;
function count(dbName, tableName) {
    return __awaiter(this, void 0, void 0, function () {
        var tableKeys;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getTableKeys(dbName, tableName)];
                case 1:
                    tableKeys = _a.sent();
                    return [2 /*return*/, tableKeys.length];
            }
        });
    });
}
exports.count = count;
function findById(dbName, tableName, id) {
    return __awaiter(this, void 0, void 0, function () {
        var doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, async_storage_1.default.getItem(getKey(dbName, tableName, id))];
                case 1:
                    doc = _a.sent();
                    return [2 /*return*/, doc ? JSON.parse(doc) : undefined];
            }
        });
    });
}
exports.findById = findById;
function save(dbName, tableName, docs) {
    if (docs === void 0) { docs = []; }
    return __awaiter(this, void 0, void 0, function () {
        var kvPairs;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    kvPairs = docs.map(function (doc) { return [getKey(dbName, tableName, doc._id), JSON.stringify(doc)]; });
                    return [4 /*yield*/, async_storage_1.default.multiSet(kvPairs)];
                case 1:
                    _a.sent();
                    return [2 /*return*/, kvPairs];
            }
        });
    });
}
exports.save = save;
function removeById(dbName, tableName, id) {
    return __awaiter(this, void 0, void 0, function () {
        var key, doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    key = getKey(dbName, tableName, id);
                    return [4 /*yield*/, async_storage_1.default.getItem(key)];
                case 1:
                    doc = _a.sent();
                    if (!doc) return [3 /*break*/, 3];
                    return [4 /*yield*/, async_storage_1.default.removeItem(key)];
                case 2:
                    _a.sent();
                    return [2 /*return*/, 1];
                case 3: return [2 /*return*/, 0];
            }
        });
    });
}
exports.removeById = removeById;
function clear(dbName, tableName) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _b = (_a = async_storage_1.default).multiRemove;
                    return [4 /*yield*/, getTableKeys(dbName, tableName)];
                case 1: return [4 /*yield*/, _b.apply(_a, [_c.sent()])];
                case 2:
                    _c.sent();
                    return [2 /*return*/, true];
            }
        });
    });
}
exports.clear = clear;
function clearDatabase(dbName, exclude) {
    if (exclude === void 0) { exclude = []; }
    return __awaiter(this, void 0, void 0, function () {
        var allKeys, keysToRemove;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, async_storage_1.default.getAllKeys()];
                case 1:
                    allKeys = _a.sent();
                    keysToRemove = allKeys.filter(function (key) { return key.indexOf("" + dbName + SEPARATOR) === 0 && !exclude.includes(key); });
                    return [4 /*yield*/, async_storage_1.default.multiRemove(keysToRemove)];
                case 2:
                    _a.sent();
                    return [2 /*return*/, true];
            }
        });
    });
}
exports.clearDatabase = clearDatabase;
//# sourceMappingURL=asyncStorage.js.map